<?php
class ControllerShippingPosten extends Controller {
	private $error = array(); 
	
	public function index() {   
		$this->load->language('shipping/posten');

		$this->document->title = $this->language->get('heading_title');
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('posten', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token']);
		}
		
		//Standard
		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');		
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		
		//Postpakker
		$this->data['text_smartpost'] = $this->language->get('text_smartpost');
		$this->data['text_apost'] = $this->language->get('text_apost');
		$this->data['text_bpost'] = $this->language->get('text_bpost');
		$this->data['text_bpakkedor'] = $this->language->get('text_bpakkedor');
		$this->data['text_bringekspress07'] = $this->language->get('text_bringekspress07');
		$this->data['text_bringekspress09'] = $this->language->get('text_bringekspress09');
		$this->data['text_norgespakke'] = $this->language->get('text_norgespakke');
		$this->data['text_padoren'] = $this->language->get('text_padoren');
		$this->data['text_servicepakke'] = $this->language->get('text_servicepakke');
		
		//Innstillinger
		$this->data['entry_city'] = $this->language->get('entry_city');
		$this->data['entry_postcode'] = $this->language->get('entry_postcode');
		$this->data['entry_service'] = $this->language->get('entry_service');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_display_weight'] = $this->language->get('entry_display_weight');
		$this->data['entry_price'] = $this->language->get('entry_price');
		$this->data['entry_description'] = $this->language->get('entry_description');

		$this->data['tab_general'] = $this->language->get('tab_general');

		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		if (isset($this->error['city'])) {
			$this->data['error_city'] = $this->error['city'];
		} else {
			$this->data['error_city'] = '';
		}

		if (isset($this->error['postcode'])) {
			$this->data['error_postcode'] = $this->error['postcode'];
		} else {
			$this->data['error_postcode'] = '';
		}

		if (isset($this->error['module'])) {
			$this->data['error_module'] = $this->error['module'];
		} else {
			$this->data['error_module'] = '';
		}

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_shipping'),
      		'separator' => ' :: '
   		);
		
   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=shipping/posten&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=shipping/posten&token=' . $this->session->data['token'];
		
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token'];
		if (isset($this->request->post['posten_city'])) {
			$this->data['posten_city'] = $this->request->post['posten_city'];
		} else {
			$this->data['posten_city'] = $this->config->get('posten_city');
		}

		if (isset($this->request->post['posten_postcode'])) {
			$this->data['posten_postcode'] = $this->request->post['posten_postcode'];
		} else {
			$this->data['posten_postcode'] = $this->config->get('posten_postcode');
		}

		//Forskjellig frakt
		if (isset($this->request->post['posten_smartpost'])) {
			$this->data['posten_smartpost'] = $this->request->post['posten_smartpost'];
		} else {
			$this->data['posten_smartpost'] = $this->config->get('posten_smartpost');
		}
		if (isset($this->request->post['posten_apost'])) {
			$this->data['posten_apost'] = $this->request->post['posten_apost'];
		} else {
			$this->data['posten_apost'] = $this->config->get('posten_apost');
		}
		if (isset($this->request->post['posten_bpost'])) {
			$this->data['posten_bpost'] = $this->request->post['posten_bpost'];
		} else {
			$this->data['posten_bpost'] = $this->config->get('posten_bpost');
		}	
		if (isset($this->request->post['posten_bpakkedordor'])) {
			$this->data['posten_bpakkedordor'] = $this->request->post['posten_bpakkedordor'];
		} else {
			$this->data['posten_bpakkedordor'] = $this->config->get('posten_bpakkedordor');
		}	
		if (isset($this->request->post['posten_ekspress07'])) {
			$this->data['posten_ekspress07'] = $this->request->post['posten_ekspress07'];
		} else {
			$this->data['posten_ekspress07'] = $this->config->get('posten_ekspress07');
		}	
		if (isset($this->request->post['posten_ekspress09'])) {
			$this->data['posten_ekspress09'] = $this->request->post['posten_ekspress09'];
		} else {
			$this->data['posten_ekspress09'] = $this->config->get('posten_ekspress09');
		}	
		if (isset($this->request->post['posten_norgespakke'])) {
			$this->data['posten_norgespakke'] = $this->request->post['posten_norgespakke'];
		} else {
			$this->data['posten_norgespakke'] = $this->config->get('posten_norgespakke');
		}	
		if (isset($this->request->post['posten_padoren'])) {
			$this->data['posten_padoren'] = $this->request->post['posten_padoren'];
		} else {
			$this->data['posten_padoren'] = $this->config->get('posten_padoren');
		}	
		if (isset($this->request->post['posten_servicepakke'])) {
			$this->data['posten_servicepakke'] = $this->request->post['posten_servicepakke'];
		} else {
			$this->data['posten_servicepakke'] = $this->config->get('posten_servicepakke');
		}	


		$this->load->model('localisation/weight_class');
		
		$this->data['weight_classes'] = $this->model_localisation_weight_class->getWeightClasses();

		if (isset($this->request->post['posten_display_weight'])) {
			$this->data['posten_display_weight'] = $this->request->post['posten_display_weight'];
		} else {
			$this->data['posten_display_weight'] = $this->config->get('posten_display_weight');
		}

		if (isset($this->request->post['posten_description'])) {
			$this->data['posten_description'] = $this->request->post['posten_description'];
		} else {
			$this->data['posten_description'] = $this->config->get('posten_description');
		}
		
		if (isset($this->request->post['posten_price'])) {
			$this->data['posten_price'] = $this->request->post['posten_price'];
		} else {
			$this->data['posten_price'] = $this->config->get('posten_price');
		}

		if (isset($this->request->post['posten_tax_class_id'])) {
			$this->data['posten_tax_class_id'] = $this->request->post['posten_tax_class_id'];
		} else {
			$this->data['posten_tax_class_id'] = $this->config->get('posten_tax_class_id');
		}
		
		$this->load->model('localisation/tax_class');
		
		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();
		
		if (isset($this->request->post['posten_geo_zone_id'])) {
			$this->data['posten_geo_zone_id'] = $this->request->post['posten_geo_zone_id'];
		} else {
			$this->data['posten_geo_zone_id'] = $this->config->get('posten_geo_zone_id');
		}
		
		$this->load->model('localisation/geo_zone');
		
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		if (isset($this->request->post['posten_status'])) {
			$this->data['posten_status'] = $this->request->post['posten_status'];
		} else {
			$this->data['posten_status'] = $this->config->get('posten_status');
		}

		if (isset($this->request->post['posten_sort_order'])) {
			$this->data['posten_sort_order'] = $this->request->post['posten_sort_order'];
		} else {
			$this->data['posten_sort_order'] = $this->config->get('posten_sort_order');
		}				
								
		$this->template = 'shipping/posten.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/posten')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['posten_city']) {
			$this->error['city'] = $this->language->get('error_city');
		}

		if (!$this->request->post['posten_postcode']) {
			$this->error['postcode'] = $this->language->get('error_postcode');
		}
		
		$weight_check = $this->config->get('config_weight_class');
		
		if ($weight_check != 'kg' && $weight_check != 'g') { $this->error['module'] = $this->language->get('error_module'); }

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
}
?>