<?php
class ModelShippingPosten extends Model {
	function getQuote($address) {
		$this->load->language('shipping/posten');
		
		if ($this->config->get('posten_status')) {
      		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('posten_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
		
      		if (!$this->config->get('posten_geo_zone_id')) {
        		$status = TRUE;
      		} elseif ($query->num_rows) {
        		$status = TRUE;
      		} else {
        		$status = FALSE;
      		}
		} else { 
			$status = FALSE;
		}

		$method_data = array();
		
		if ($status) {
			$service_code = array(
				'other' => array(
					// service code 7 seems to be gone after January 2, 2007
					'bringapost' => $this->language->get('text_other_origin_07'),
					'08' => $this->language->get('text_other_origin_08'),
					'11' => $this->language->get('text_other_origin_11'),
					'54' => $this->language->get('text_other_origin_54'),
					'65' => $this->language->get('text_other_origin_65')
				)
			);

			//SKAL DETTE VÆRE EN FUNKSJON?
			$productCode = 'SERVICEPAKKE';

			$header[] = 'Host: fraktguide.bring.no';
			$header[] = 'User-Agent: Open Cart 1.8b';
			$header[] = 'Connection: close';
			
			$weight_class = $this->config->get('config_weight_class');

			if ($weight_class = 'g') {
				$weight = $this->cart->getWeight();
			}
			
			if ($weight_class = 'kg') {
				$weight = $this->cart->getWeight() * 1000;
			}
			
			$request = join('&', array(
				'from=' . $this->config->get('posten_postcode'),
				'to=' . $address['postcode'],
				'weightInGrams=' . $weight,
				'postingAtPostoffice=true',
				'edi=false',
				'priceAdjustment=' . $this->config->get('posten_price'),
				//'length=30',
				//'width=40',
				//'height=40'.
));
			
			$url = ('fraktguide.bring.no/fraktguide/products/all.xml?' . $request);
			$ch = curl_init($url);
			
			curl_setopt($ch, CURLOPT_HTTPHEADER, $header);  
			curl_setopt($ch, CURLOPT_POST, 0);  
			curl_setopt($ch, CURLOPT_TIMEOUT, 60);  
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);  
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0); 
			
			$result = curl_exec($ch);

			curl_close($ch);
					
			$error = '';
			
			$error_msg = '';
			
			$quote_data = array();
			
			if ($result) { 
				$dom = new DOMDocument('1.0', 'UTF-8');
				$dom->loadXml($result);	

				$response_status = $dom->getElementsByTagName('TraceMessages')->item(0);

				//Dårlig måte å finne feilmeldinger på, men det får gå ..
				if(strpos($dom->saveXML(), 'FG_INPUT_002')) {
					$error_msg .= 'FG_INPUT_002: Feil format på oppgitt postnummer'; 
				}
				elseif(strpos($dom->saveXML(), 'FG_INPUT_021')) {
					$error_msg .= 'FG_INPUT_021: Oppgitt postnummer er ikke gyldig'; 
				}
				elseif(strpos($dom->saveXML(), 'FG_INPUT_022')) {
					$error_msg .= 'FG_INPUT_022: Vekt eller volum ikke oppgitt'; 
				}
				elseif(strpos($dom->saveXML(), 'FG_INPUT_000')) {
					$error_msg .= 'FG_INPUT_000: Ikke tilgjengelig til oppgitt postnummer';
				
				} else {
				
				$pakker = $dom->getElementsByTagName("Product");

				foreach ($pakker as $value) {
					$code = $value->getElementsByTagName("ProductId")->item(0)->nodeValue;

					$service_info = $value->getElementsByTagName("GuiInformation")->item(0);
					$service = $service_info->getElementsByTagName("ProductName")->item(0)->nodeValue;
					$description = $service_info->getElementsByTagName("DescriptionText")->item(0)->nodeValue;

					$charges = $value->getElementsByTagName("Price")->item(0);
					$total_charges = $charges->getElementsByTagName("PackagePriceWithoutAdditionalServices")->item(0);
					$cost = $total_charges->getElementsByTagName("AmountWithVAT")->item(0)->nodeValue;

					if (!($code && $cost && $service)) {
						continue;
					}

					if ($this->config->get('posten_' . str_replace("-","",strtolower($code))) == '1') {
						$quote_data[$code] = array(
							'id'           => 'posten.' . $code,
							'title'        => $service,
							'cost'         => $this->currency->convert($cost, 'NOK', $this->currency->getCode()),
							'tax_class_id' => $this->config->get('posten_tax_class_id'),
							'description'  => $description,
							'desc_en'	   => $this->config->get('posten_description'),
							'text'         => $this->currency->format($this->tax->calculate($this->currency->convert($cost, 'NOK', $this->currency->getCode()), $this->config->get('posten_tax_class_id'), $this->config->get('config_tax')))
						);
					}
					}
				}
			}
			
			$title = $this->language->get('text_title');
			
			if ($this->config->get('posten_display_weight')) {	  
				$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->cart->getWeight() . ' ' . $this->config->get('config_weight_class') . ')';
			}
			
			$method_data = array();

			$method_data = array(
				'id'         => 'posten',
				'title'      => $title,
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('posten_sort_order'),
				'error'      => $error_msg,
			);
		}

		return $method_data;
	}
}
?>